diff --git a/drivers/net/virtio/virtio_user/vhost.h b/drivers/net/virtio/virtio_user/vhost.h
index 4fba203cc5..b488ac78a1 100644
--- a/drivers/net/virtio/virtio_user/vhost.h
+++ b/drivers/net/virtio/virtio_user/vhost.h
@@ -46,23 +46,6 @@ struct vhost_vring_addr {
 	uint64_t log_guest_addr;
 };
 
-#ifndef VHOST_USER_F_PROTOCOL_FEATURES
-#define VHOST_USER_F_PROTOCOL_FEATURES 30
-#endif
-
-/** Protocol features. */
-#ifndef VHOST_USER_PROTOCOL_F_MQ
-#define VHOST_USER_PROTOCOL_F_MQ 0
-#endif
-
-#ifndef VHOST_USER_PROTOCOL_F_REPLY_ACK
-#define VHOST_USER_PROTOCOL_F_REPLY_ACK 3
-#endif
-
-#ifndef VHOST_USER_PROTOCOL_F_STATUS
-#define VHOST_USER_PROTOCOL_F_STATUS 16
-#endif
-
 struct vhost_memory_region {
 	uint64_t guest_phys_addr;
 	uint64_t memory_size; /* bytes */
@@ -74,11 +57,10 @@ struct virtio_user_dev;
 
 struct virtio_user_backend_ops {
 	int (*setup)(struct virtio_user_dev *dev);
+	int (*get_backend_features)(uint64_t *features);
 	int (*set_owner)(struct virtio_user_dev *dev);
 	int (*get_features)(struct virtio_user_dev *dev, uint64_t *features);
 	int (*set_features)(struct virtio_user_dev *dev, uint64_t features);
-	int (*get_protocol_features)(struct virtio_user_dev *dev, uint64_t *features);
-	int (*set_protocol_features)(struct virtio_user_dev *dev, uint64_t features);
 	int (*set_memory_table)(struct virtio_user_dev *dev);
 	int (*set_vring_enable)(struct virtio_user_dev *dev, struct vhost_vring_state *state);
 	int (*set_vring_num)(struct virtio_user_dev *dev, struct vhost_vring_state *state);
diff --git a/drivers/net/virtio/virtio_user/vhost_kernel.c b/drivers/net/virtio/virtio_user/vhost_kernel.c
index c4c9c9d085..2fd00afa84 100644
--- a/drivers/net/virtio/virtio_user/vhost_kernel.c
+++ b/drivers/net/virtio/virtio_user/vhost_kernel.c
@@ -445,8 +445,17 @@ vhost_kernel_enable_queue_pair(struct virtio_user_dev *dev,
 	return 0;
 }
 
+static int
+vhost_kernel_get_backend_features(uint64_t *features)
+{
+	*features = 0;
+
+	return 0;
+}
+
 struct virtio_user_backend_ops virtio_ops_kernel = {
 	.setup = vhost_kernel_setup,
+	.get_backend_features = vhost_kernel_get_backend_features,
 	.set_owner = vhost_kernel_set_owner,
 	.get_features = vhost_kernel_get_features,
 	.set_features = vhost_kernel_set_features,
diff --git a/drivers/net/virtio/virtio_user/vhost_user.c b/drivers/net/virtio/virtio_user/vhost_user.c
index 94a33326ae..f67c40e047 100644
--- a/drivers/net/virtio/virtio_user/vhost_user.c
+++ b/drivers/net/virtio/virtio_user/vhost_user.c
@@ -17,6 +17,29 @@
 #include "vhost.h"
 #include "virtio_user_dev.h"
 
+
+#ifndef VHOST_USER_F_PROTOCOL_FEATURES
+#define VHOST_USER_F_PROTOCOL_FEATURES 30
+#endif
+
+/** Protocol features. */
+#ifndef VHOST_USER_PROTOCOL_F_MQ
+#define VHOST_USER_PROTOCOL_F_MQ 0
+#endif
+
+#ifndef VHOST_USER_PROTOCOL_F_REPLY_ACK
+#define VHOST_USER_PROTOCOL_F_REPLY_ACK 3
+#endif
+
+#ifndef VHOST_USER_PROTOCOL_F_STATUS
+#define VHOST_USER_PROTOCOL_F_STATUS 16
+#endif
+
+#define VHOST_USER_SUPPORTED_PROTOCOL_FEATURES		\
+	(1ULL << VHOST_USER_PROTOCOL_F_MQ |		\
+	 1ULL << VHOST_USER_PROTOCOL_F_REPLY_ACK |	\
+	 1ULL << VHOST_USER_PROTOCOL_F_STATUS)
+
 /* The version of the protocol we support */
 #define VHOST_USER_VERSION    0x1
 
@@ -192,11 +215,11 @@ vhost_user_set_owner(struct virtio_user_dev *dev)
 }
 
 static int
-vhost_user_get_features(struct virtio_user_dev *dev, uint64_t *features)
+vhost_user_get_protocol_features(struct virtio_user_dev *dev, uint64_t *features)
 {
 	int ret;
 	struct vhost_user_msg msg = {
-		.request = VHOST_USER_GET_FEATURES,
+		.request = VHOST_USER_GET_PROTOCOL_FEATURES,
 		.flags = VHOST_USER_VERSION,
 	};
 
@@ -208,7 +231,7 @@ vhost_user_get_features(struct virtio_user_dev *dev, uint64_t *features)
 	if (ret < 0)
 		goto err;
 
-	if (msg.request != VHOST_USER_GET_FEATURES) {
+	if (msg.request != VHOST_USER_GET_PROTOCOL_FEATURES) {
 		PMD_DRV_LOG(ERR, "Unexpected request type (%d)", msg.request);
 		goto err;
 	}
@@ -222,17 +245,17 @@ vhost_user_get_features(struct virtio_user_dev *dev, uint64_t *features)
 
 	return 0;
 err:
-	PMD_DRV_LOG(ERR, "Failed to get backend features");
+	PMD_DRV_LOG(ERR, "Failed to get backend protocol features");
 
 	return -1;
 }
 
 static int
-vhost_user_set_features(struct virtio_user_dev *dev, uint64_t features)
+vhost_user_set_protocol_features(struct virtio_user_dev *dev, uint64_t features)
 {
 	int ret;
 	struct vhost_user_msg msg = {
-		.request = VHOST_USER_SET_FEATURES,
+		.request = VHOST_USER_SET_PROTOCOL_FEATURES,
 		.flags = VHOST_USER_VERSION,
 		.size = sizeof(features),
 		.payload.u64 = features,
@@ -240,7 +263,7 @@ vhost_user_set_features(struct virtio_user_dev *dev, uint64_t features)
 
 	ret = vhost_user_write(dev->vhostfd, &msg, NULL, 0);
 	if (ret < 0) {
-		PMD_DRV_LOG(ERR, "Failed to set features");
+		PMD_DRV_LOG(ERR, "Failed to set protocol features");
 		return -1;
 	}
 
@@ -248,11 +271,11 @@ vhost_user_set_features(struct virtio_user_dev *dev, uint64_t features)
 }
 
 static int
-vhost_user_get_protocol_features(struct virtio_user_dev *dev, uint64_t *features)
+vhost_user_get_features(struct virtio_user_dev *dev, uint64_t *features)
 {
 	int ret;
 	struct vhost_user_msg msg = {
-		.request = VHOST_USER_GET_PROTOCOL_FEATURES,
+		.request = VHOST_USER_GET_FEATURES,
 		.flags = VHOST_USER_VERSION,
 	};
 
@@ -264,7 +287,7 @@ vhost_user_get_protocol_features(struct virtio_user_dev *dev, uint64_t *features
 	if (ret < 0)
 		goto err;
 
-	if (msg.request != VHOST_USER_GET_PROTOCOL_FEATURES) {
+	if (msg.request != VHOST_USER_GET_FEATURES) {
 		PMD_DRV_LOG(ERR, "Unexpected request type (%d)", msg.request);
 		goto err;
 	}
@@ -276,19 +299,36 @@ vhost_user_get_protocol_features(struct virtio_user_dev *dev, uint64_t *features
 
 	*features = msg.payload.u64;
 
+	if (!(*features & (1ULL << VHOST_USER_F_PROTOCOL_FEATURES)))
+		return 0;
+
+	/* Negotiate protocol features */
+	ret = vhost_user_get_protocol_features(dev, &dev->protocol_features);
+	if (ret < 0)
+		goto err;
+
+	dev->protocol_features &= VHOST_USER_SUPPORTED_PROTOCOL_FEATURES;
+
+	ret = vhost_user_set_protocol_features(dev, dev->protocol_features);
+	if (ret < 0)
+		goto err;
+
+	if (!(dev->protocol_features & (1ULL << VHOST_USER_PROTOCOL_F_MQ)))
+		dev->unsupported_features |= (1ull << VIRTIO_NET_F_MQ);
+
 	return 0;
 err:
-	PMD_DRV_LOG(ERR, "Failed to get backend protocol features");
+	PMD_DRV_LOG(ERR, "Failed to get backend features");
 
 	return -1;
 }
 
 static int
-vhost_user_set_protocol_features(struct virtio_user_dev *dev, uint64_t features)
+vhost_user_set_features(struct virtio_user_dev *dev, uint64_t features)
 {
 	int ret;
 	struct vhost_user_msg msg = {
-		.request = VHOST_USER_SET_PROTOCOL_FEATURES,
+		.request = VHOST_USER_SET_FEATURES,
 		.flags = VHOST_USER_VERSION,
 		.size = sizeof(features),
 		.payload.u64 = features,
@@ -296,7 +336,7 @@ vhost_user_set_protocol_features(struct virtio_user_dev *dev, uint64_t features)
 
 	ret = vhost_user_write(dev->vhostfd, &msg, NULL, 0);
 	if (ret < 0) {
-		PMD_DRV_LOG(ERR, "Failed to set protocol features");
+		PMD_DRV_LOG(ERR, "Failed to set features");
 		return -1;
 	}
 
@@ -765,13 +805,20 @@ vhost_user_enable_queue_pair(struct virtio_user_dev *dev,
 	return 0;
 }
 
+static int
+vhost_user_get_backend_features(uint64_t *features)
+{
+	*features = 1ULL << VHOST_USER_F_PROTOCOL_FEATURES;
+
+	return 0;
+}
+
 struct virtio_user_backend_ops virtio_ops_user = {
 	.setup = vhost_user_setup,
+	.get_backend_features = vhost_user_get_backend_features,
 	.set_owner = vhost_user_set_owner,
 	.get_features = vhost_user_get_features,
 	.set_features = vhost_user_set_features,
-	.get_protocol_features = vhost_user_get_protocol_features,
-	.set_protocol_features = vhost_user_set_protocol_features,
 	.set_memory_table = vhost_user_set_memory_table,
 	.set_vring_enable = vhost_user_set_vring_enable,
 	.set_vring_num = vhost_user_set_vring_num,
diff --git a/drivers/net/virtio/virtio_user/vhost_vdpa.c b/drivers/net/virtio/virtio_user/vhost_vdpa.c
index ecfaeaf814..c826f333e0 100644
--- a/drivers/net/virtio/virtio_user/vhost_vdpa.c
+++ b/drivers/net/virtio/virtio_user/vhost_vdpa.c
@@ -312,8 +312,17 @@ vhost_vdpa_enable_queue_pair(struct virtio_user_dev *dev,
 	return 0;
 }
 
+static int
+vhost_vdpa_get_backend_features(uint64_t *features)
+{
+	*features = 0;
+
+	return 0;
+}
+
 struct virtio_user_backend_ops virtio_ops_vdpa = {
 	.setup = vhost_vdpa_setup,
+	.get_backend_features = vhost_vdpa_get_backend_features,
 	.set_owner = vhost_vdpa_set_owner,
 	.get_features = vhost_vdpa_get_features,
 	.set_features = vhost_vdpa_set_features,
diff --git a/drivers/net/virtio/virtio_user/virtio_user_dev.c b/drivers/net/virtio/virtio_user/virtio_user_dev.c
index 19d59d401e..974de133bc 100644
--- a/drivers/net/virtio/virtio_user/virtio_user_dev.c
+++ b/drivers/net/virtio/virtio_user/virtio_user_dev.c
@@ -479,13 +479,7 @@ virtio_user_dev_setup(struct virtio_user_dev *dev)
 	 1ULL << VIRTIO_NET_F_GUEST_TSO6	|	\
 	 1ULL << VIRTIO_F_IN_ORDER		|	\
 	 1ULL << VIRTIO_F_VERSION_1		|	\
-	 1ULL << VIRTIO_F_RING_PACKED		|	\
-	 1ULL << VHOST_USER_F_PROTOCOL_FEATURES)
-
-#define VIRTIO_USER_SUPPORTED_PROTOCOL_FEATURES		\
-	(1ULL << VHOST_USER_PROTOCOL_F_MQ |		\
-	 1ULL << VHOST_USER_PROTOCOL_F_REPLY_ACK |	\
-	 1ULL << VHOST_USER_PROTOCOL_F_STATUS)
+	 1ULL << VIRTIO_F_RING_PACKED)
 
 int
 virtio_user_dev_init(struct virtio_user_dev *dev, char *path, int queues,
@@ -493,7 +487,7 @@ virtio_user_dev_init(struct virtio_user_dev *dev, char *path, int queues,
 		     int server, int mrg_rxbuf, int in_order, int packed_vq,
 		     enum virtio_user_backend_type backend_type)
 {
-	uint64_t protocol_features = 0;
+	uint64_t backend_features;
 
 	pthread_mutex_init(&dev->mutex, NULL);
 	strlcpy(dev->path, path, PATH_MAX);
@@ -504,8 +498,7 @@ virtio_user_dev_init(struct virtio_user_dev *dev, char *path, int queues,
 	dev->is_server = server;
 	dev->mac_specified = 0;
 	dev->frontend_features = 0;
-	dev->unsupported_features = ~VIRTIO_USER_SUPPORTED_FEATURES;
-	dev->protocol_features = VIRTIO_USER_SUPPORTED_PROTOCOL_FEATURES;
+	dev->unsupported_features = 0;
 	dev->backend_type = backend_type;
 
 	parse_mac(dev, mac);
@@ -520,37 +513,21 @@ virtio_user_dev_init(struct virtio_user_dev *dev, char *path, int queues,
 		return -1;
 	}
 
-	if (dev->backend_type != VIRTIO_USER_BACKEND_VHOST_USER)
-		dev->unsupported_features |=
-			(1ULL << VHOST_USER_F_PROTOCOL_FEATURES);
-
 	if (dev->ops->set_owner(dev) < 0) {
 		PMD_INIT_LOG(ERR, "(%s) Failed to set backend owner", dev->path);
 		return -1;
 	}
 
-	if (dev->ops->get_features(dev, &dev->device_features) < 0) {
+	if (dev->ops->get_backend_features(&backend_features) < 0) {
 		PMD_INIT_LOG(ERR, "(%s) Failed to get backend features", dev->path);
 		return -1;
 	}
 
-	if (dev->device_features & (1ULL << VHOST_USER_F_PROTOCOL_FEATURES)) {
-		if (dev->ops->get_protocol_features(dev, &protocol_features)) {
-			PMD_INIT_LOG(ERR, "(%s) Failed to get backend protocol features",
-					dev->path);
-			return -1;
-		}
-
-		dev->protocol_features &= protocol_features;
+	dev->unsupported_features = ~(VIRTIO_USER_SUPPORTED_FEATURES | backend_features);
 
-		if (dev->ops->set_protocol_features(dev, dev->protocol_features)) {
-			PMD_INIT_LOG(ERR, "(%s) Failed to set backend protocol features",
-					dev->path);
-			return -1;
-		}
-
-		if (!(dev->protocol_features & (1ULL << VHOST_USER_PROTOCOL_F_MQ)))
-			dev->unsupported_features |= (1ull << VIRTIO_NET_F_MQ);
+	if (dev->ops->get_features(dev, &dev->device_features) < 0) {
+		PMD_INIT_LOG(ERR, "(%s) Failed to get device features", dev->path);
+		return -1;
 	}
 
 	if (!mrg_rxbuf)
diff --git a/drivers/net/virtio/virtio_user/virtio_user_dev.h b/drivers/net/virtio/virtio_user/virtio_user_dev.h
index 0eb481ae21..b2da2944e9 100644
--- a/drivers/net/virtio/virtio_user/virtio_user_dev.h
+++ b/drivers/net/virtio/virtio_user/virtio_user_dev.h
@@ -30,6 +30,7 @@ struct virtio_user_dev {
 	int		vhostfd;
 	int		listenfd;   /* listening fd */
 	bool		is_server;  /* server or client mode */
+	uint64_t	protocol_features; /* negotiated protocol features*/
 
 	/* for vhost_kernel backend */
 	char		*ifname;
@@ -49,9 +50,7 @@ struct virtio_user_dev {
 	uint64_t	device_features; /* supported features by device */
 	uint64_t	frontend_features; /* enabled frontend features */
 	uint64_t	unsupported_features; /* unsupported features mask */
-	uint64_t	protocol_features; /* negotiated protocol features
-					    * (Vhost-user only)
-					    */
+
 	uint8_t		status;
 	uint16_t	net_status;
 	uint16_t	port_id;
diff --git a/drivers/net/virtio/virtio_user_ethdev.c b/drivers/net/virtio/virtio_user_ethdev.c
index c4cfd3daed..77ad468768 100644
--- a/drivers/net/virtio/virtio_user_ethdev.c
+++ b/drivers/net/virtio/virtio_user_ethdev.c
@@ -70,7 +70,6 @@ virtio_user_server_reconnect(struct virtio_user_dev *dev)
 	int ret, connectfd, old_status;
 	struct rte_eth_dev *eth_dev = &rte_eth_devices[dev->port_id];
 	struct virtio_hw *hw = &dev->hw;
-	uint64_t protocol_features;
 
 	connectfd = accept(dev->listenfd, NULL, NULL);
 	if (connectfd < 0)
@@ -91,22 +90,6 @@ virtio_user_server_reconnect(struct virtio_user_dev *dev)
 		return -1;
 	}
 
-	if (dev->device_features &
-			(1ULL << VHOST_USER_F_PROTOCOL_FEATURES)) {
-		if (dev->ops->get_protocol_features(dev, &protocol_features))
-			return -1;
-
-		/* Offer VHOST_USER_PROTOCOL_F_STATUS */
-		dev->protocol_features |= (1ULL << VHOST_USER_PROTOCOL_F_STATUS);
-		dev->protocol_features &= protocol_features;
-
-		if (dev->ops->set_protocol_features(dev, dev->protocol_features))
-			return -1;
-
-		if (!(dev->protocol_features & (1ULL << VHOST_USER_PROTOCOL_F_MQ)))
-			dev->unsupported_features |= (1ull << VIRTIO_NET_F_MQ);
-	}
-
 	dev->device_features |= dev->frontend_features;
 
 	/* umask vhost-user unsupported features */