diff --git a/drivers/net/virtio/virtio_user/vhost.h b/drivers/net/virtio/virtio_user/vhost.h
index 2d433d5966..94c524547e 100644
--- a/drivers/net/virtio/virtio_user/vhost.h
+++ b/drivers/net/virtio/virtio_user/vhost.h
@@ -118,6 +118,8 @@ struct virtio_user_backend_ops {
 	int (*set_vring_num)(struct virtio_user_dev *dev, struct vhost_vring_state *state);
 	int (*set_vring_base)(struct virtio_user_dev *dev, struct vhost_vring_state *state);
 	int (*get_vring_base)(struct virtio_user_dev *dev, struct vhost_vring_state *state);
+	int (*set_vring_call)(struct virtio_user_dev *dev, struct vhost_vring_file *file);
+	int (*set_vring_kick)(struct virtio_user_dev *dev, struct vhost_vring_file *file);
 	int (*send_request)(struct virtio_user_dev *dev,
 			    enum vhost_user_request req,
 			    void *arg);
diff --git a/drivers/net/virtio/virtio_user/vhost_kernel.c b/drivers/net/virtio/virtio_user/vhost_kernel.c
index e12fe74f46..dc5358bc15 100644
--- a/drivers/net/virtio/virtio_user/vhost_kernel.c
+++ b/drivers/net/virtio/virtio_user/vhost_kernel.c
@@ -259,11 +259,44 @@ vhost_kernel_get_vring_base(struct virtio_user_dev *dev, struct vhost_vring_stat
 	return vhost_kernel_set_vring(dev, VHOST_GET_VRING_BASE, state);
 }
 
+static int
+vhost_kernel_set_vring_file(struct virtio_user_dev *dev, uint64_t req,
+		struct vhost_vring_file *file)
+{
+	int ret, fd;
+	unsigned int index = file->index;
+
+	/* Convert from queue index to queue-pair & offset */
+	fd = dev->vhostfds[file->index / 2];
+	file->index %= 2;
+
+	ret = vhost_kernel_ioctl(fd, req, file);
+	if (ret < 0) {
+		PMD_DRV_LOG(ERR, "Failed to set vring file (request %" PRIu64 ")", req);
+		return -1;
+	}
+
+	/* restore index back to queue index */
+	file->index = index;
+
+	return 0;
+}
+
+static int
+vhost_kernel_set_vring_kick(struct virtio_user_dev *dev, struct vhost_vring_file *file)
+{
+	return vhost_kernel_set_vring_file(dev, VHOST_SET_VRING_KICK, file);
+}
+
+static int
+vhost_kernel_set_vring_call(struct virtio_user_dev *dev, struct vhost_vring_file *file)
+{
+	return vhost_kernel_set_vring_file(dev, VHOST_SET_VRING_CALL, file);
+}
+
 static uint64_t vhost_req_user_to_kernel[] = {
 	[VHOST_USER_RESET_OWNER] = VHOST_RESET_OWNER,
-	[VHOST_USER_SET_VRING_CALL] = VHOST_SET_VRING_CALL,
 	[VHOST_USER_SET_VRING_ADDR] = VHOST_SET_VRING_ADDR,
-	[VHOST_USER_SET_VRING_KICK] = VHOST_SET_VRING_KICK,
 };
 
 static int
@@ -283,8 +316,6 @@ vhost_kernel_send_request(struct virtio_user_dev *dev,
 
 	switch (req_kernel) {
 	case VHOST_SET_VRING_ADDR:
-	case VHOST_SET_VRING_KICK:
-	case VHOST_SET_VRING_CALL:
 		queue_sel = *(unsigned int *)arg;
 		vhostfd = dev->vhostfds[queue_sel / 2];
 		*(unsigned int *)arg = queue_sel % 2;
@@ -440,6 +471,8 @@ struct virtio_user_backend_ops virtio_ops_kernel = {
 	.set_vring_num = vhost_kernel_set_vring_num,
 	.set_vring_base = vhost_kernel_set_vring_base,
 	.get_vring_base = vhost_kernel_get_vring_base,
+	.set_vring_call = vhost_kernel_set_vring_call,
+	.set_vring_kick = vhost_kernel_set_vring_kick,
 	.send_request = vhost_kernel_send_request,
 	.enable_qp = vhost_kernel_enable_queue_pair
 };
diff --git a/drivers/net/virtio/virtio_user/vhost_user.c b/drivers/net/virtio/virtio_user/vhost_user.c
index c39be24ce4..06d17cadcb 100644
--- a/drivers/net/virtio/virtio_user/vhost_user.c
+++ b/drivers/net/virtio/virtio_user/vhost_user.c
@@ -498,13 +498,51 @@ vhost_user_get_vring_base(struct virtio_user_dev *dev, struct vhost_vring_state
 	return -1;
 }
 
+static int
+vhost_user_set_vring_file(struct virtio_user_dev *dev, enum vhost_user_request req,
+		struct vhost_vring_file *file)
+{
+	int ret;
+	int fd = file->fd;
+	int num_fd = 0;
+	struct vhost_user_msg msg = {
+		.request = req,
+		.flags = VHOST_USER_VERSION,
+		.size = sizeof(msg.payload.u64),
+		.payload.u64 = file->index & VHOST_USER_VRING_IDX_MASK,
+	};
+
+	if (fd >= 0)
+		num_fd++;
+	else
+		msg.payload.u64 |= VHOST_USER_VRING_NOFD_MASK;
+
+	ret = vhost_user_write(dev->vhostfd, &msg, &fd, num_fd);
+	if (ret < 0) {
+		PMD_DRV_LOG(ERR, "Failed to set vring file (request %d)", req);
+		return -1;
+	}
+
+	return 0;
+}
+
+static int
+vhost_user_set_vring_call(struct virtio_user_dev *dev, struct vhost_vring_file *file)
+{
+	return vhost_user_set_vring_file(dev, VHOST_USER_SET_VRING_CALL, file);
+}
+
+static int
+vhost_user_set_vring_kick(struct virtio_user_dev *dev, struct vhost_vring_file *file)
+{
+	return vhost_user_set_vring_file(dev, VHOST_USER_SET_VRING_KICK, file);
+}
+
 static struct vhost_user_msg m;
 
 const char * const vhost_msg_strings[] = {
 	[VHOST_USER_RESET_OWNER] = "VHOST_RESET_OWNER",
-	[VHOST_USER_SET_VRING_CALL] = "VHOST_SET_VRING_CALL",
 	[VHOST_USER_SET_VRING_ADDR] = "VHOST_SET_VRING_ADDR",
-	[VHOST_USER_SET_VRING_KICK] = "VHOST_SET_VRING_KICK",
 	[VHOST_USER_SET_STATUS] = "VHOST_SET_STATUS",
 	[VHOST_USER_GET_STATUS] = "VHOST_GET_STATUS",
 };
@@ -577,8 +615,6 @@ vhost_user_sock(struct virtio_user_dev *dev,
 		msg.size = sizeof(m.payload.addr);
 		break;
 
-	case VHOST_USER_SET_VRING_KICK:
-	case VHOST_USER_SET_VRING_CALL:
 	case VHOST_USER_SET_VRING_ERR:
 		file = arg;
 		msg.payload.u64 = file->index & VHOST_USER_VRING_IDX_MASK;
@@ -749,6 +785,8 @@ struct virtio_user_backend_ops virtio_ops_user = {
 	.set_vring_num = vhost_user_set_vring_num,
 	.set_vring_base = vhost_user_set_vring_base,
 	.get_vring_base = vhost_user_get_vring_base,
+	.set_vring_call = vhost_user_set_vring_call,
+	.set_vring_kick = vhost_user_set_vring_kick,
 	.send_request = vhost_user_sock,
 	.enable_qp = vhost_user_enable_queue_pair
 };
diff --git a/drivers/net/virtio/virtio_user/vhost_vdpa.c b/drivers/net/virtio/virtio_user/vhost_vdpa.c
index 323751093a..304a808b55 100644
--- a/drivers/net/virtio/virtio_user/vhost_vdpa.c
+++ b/drivers/net/virtio/virtio_user/vhost_vdpa.c
@@ -38,9 +38,7 @@
 
 static uint64_t vhost_req_user_to_vdpa[] = {
 	[VHOST_USER_RESET_OWNER] = VHOST_RESET_OWNER,
-	[VHOST_USER_SET_VRING_CALL] = VHOST_SET_VRING_CALL,
 	[VHOST_USER_SET_VRING_ADDR] = VHOST_SET_VRING_ADDR,
-	[VHOST_USER_SET_VRING_KICK] = VHOST_SET_VRING_KICK,
 	[VHOST_USER_SET_STATUS] = VHOST_VDPA_SET_STATUS,
 	[VHOST_USER_GET_STATUS] = VHOST_VDPA_GET_STATUS,
 };
@@ -364,6 +362,18 @@ vhost_vdpa_get_vring_base(struct virtio_user_dev *dev, struct vhost_vring_state
 	return vhost_vdpa_ioctl(dev->vhostfd, VHOST_GET_VRING_BASE, state);
 }
 
+static int
+vhost_vdpa_set_vring_call(struct virtio_user_dev *dev, struct vhost_vring_file *file)
+{
+	return vhost_vdpa_ioctl(dev->vhostfd, VHOST_SET_VRING_CALL, file);
+}
+
+static int
+vhost_vdpa_set_vring_kick(struct virtio_user_dev *dev, struct vhost_vring_file *file)
+{
+	return vhost_vdpa_ioctl(dev->vhostfd, VHOST_SET_VRING_KICK, file);
+}
+
 /* with below features, vhost vdpa does not need to do the checksum and TSO,
  * these info will be passed to virtio_user through virtio net header.
  */
@@ -393,8 +403,6 @@ vhost_vdpa_send_request(struct virtio_user_dev *dev,
 
 	switch (req_vdpa) {
 	case VHOST_SET_VRING_ADDR:
-	case VHOST_SET_VRING_KICK:
-	case VHOST_SET_VRING_CALL:
 		PMD_DRV_LOG(DEBUG, "vhostfd=%d, index=%u",
 			    dev->vhostfd, *(unsigned int *)arg);
 		break;
@@ -474,6 +482,8 @@ struct virtio_user_backend_ops virtio_ops_vdpa = {
 	.set_vring_num = vhost_vdpa_set_vring_num,
 	.set_vring_base = vhost_vdpa_set_vring_base,
 	.get_vring_base = vhost_vdpa_get_vring_base,
+	.set_vring_call = vhost_vdpa_set_vring_call,
+	.set_vring_kick = vhost_vdpa_set_vring_kick,
 	.send_request = vhost_vdpa_send_request,
 	.enable_qp = vhost_vdpa_enable_queue_pair,
 	.dma_map = vhost_vdpa_dma_map_batch,
diff --git a/drivers/net/virtio/virtio_user/virtio_user_dev.c b/drivers/net/virtio/virtio_user/virtio_user_dev.c
index 0b30c10016..4383e403da 100644
--- a/drivers/net/virtio/virtio_user/virtio_user_dev.c
+++ b/drivers/net/virtio/virtio_user/virtio_user_dev.c
@@ -40,7 +40,7 @@ virtio_user_create_queue(struct virtio_user_dev *dev, uint32_t queue_sel)
 
 	file.index = queue_sel;
 	file.fd = dev->callfds[queue_sel];
-	dev->ops->send_request(dev, VHOST_USER_SET_VRING_CALL, &file);
+	dev->ops->set_vring_call(dev, &file);
 
 	return 0;
 }
@@ -89,7 +89,7 @@ virtio_user_kick_queue(struct virtio_user_dev *dev, uint32_t queue_sel)
 	 */
 	file.index = queue_sel;
 	file.fd = dev->kickfds[queue_sel];
-	dev->ops->send_request(dev, VHOST_USER_SET_VRING_KICK, &file);
+	dev->ops->set_vring_kick(dev, &file);
 
 	return 0;
 }